20 :
30 REMark first pass
40 :
50 initialise_arrays
60 screen
70 file$=file_prompt$
80 open_file file$
90 pc=0:REMark default pc
100 ec%=0
110 :
120 REMark first pass main execution loop
130 :
140 pass=0
150 PRINT:PRINT'First pass':PRINT
160 REPeat pass1
170   lab$=''
180   REPeat lp
190     line$=read_line$
200     whole_line$=line$
210     fld$=nxt_fld$(line$)
220     IF fld$<>'':EXIT lp
230   END REPeat lp
250   IF fld$='END':EXIT pass1
260   IF fld$(1)='*':NEXT pass1
270   IF fld$(LEN(fld$))=':' THEN
280       lab$=fld$(TO LEN(fld$)-1)
290       IF LEN(lab$)>8 THEN
300           lab$=lab$(TO 8)
310       END IF
320       IF fnd_sym(lab$)<>2^33 THEN
330           ec%=ferror(fld$&' multiple definition',ec%)
340           NEXT pass1
350         ELSE
360           add_sym lab$,pc
370           IF LEN(line$)>0:fld$=nxt_fld$(line$)
380       END IF
390   END IF
400   link=mnemonic(fld$)
410   IF link=-1 THEN
420       ec%=ferror(fld$&' not found in mnemonic list',ec%)
430       NEXT pass1
440   END IF
450 :
460 REMark is it a pseudo operand?
470 :
480   IF link>=56 THEN
490       pseudo_op lab$,fld$,pc
500       NEXT pass1
510   END IF
520   pc=pc+2
530   IF LEN(line$)=0:NEXT pass1
540   IF fld$='MOVEQ':NEXT pass1
550   op$=nxt_fld$(line$)
560   IF op$='' OR op$(1)='*':NEXT pass1
570   IF cnt_ops(op$)=1 THEN
580       src$=op$
590       dest$=''
600   END IF
610   IF cnt_ops(op$)=0 THEN
620       src$=ferror(whole-line$&' - illegal operand',ec%)
630       NEXT pass1
640   END IF
650   IF cnt_ops(op$)=2 THEN
660       src$=op1$(op$)
670       dest$=op2$(op$)
680   END IF
690 :
700 REMark determine source operand type
710 :
720   src_type%=op_type(src$,fld$,'s')
730 :
740   IF src_type%=0 OR src_type%=8 OR src_type%=9 THEN
750       IF short_branch(fld$,link,src$)=1 THEN
760           NEXT pass1
770       END IF
780       IF branch(fld$,link)=1 THEN
790           pc=pc+2
800           NEXT pass1
810       END IF
820   END IF
830   pc=pc+overhead(src_type%,fld$,src$)
840   IF dest$='':NEXT pass1
850 :
860 REMark determine destination operand
870 :
880   dest_type%=op_type(dest$,fld$,'d')
890   IF branch(fld$,link) THEN :pc=pc+2:NEXT pass1
900   pc=pc+overhead(dest_type%,fld$,dest$)
910 END REPeat pass1
915 old_pc=pc
920 IF ec%>0 THEN
930     display_errors ec%
940     close_file file$
945     CLOSE#channel
950     STOP
960 END IF
970 :
980 REMark second pass
990 :
1000 reset_pointer file$
1010 pc=0:REMark default pc again
1020 len%=0
1030 ec%=0
1040 :
1050 REMark second pass main execution loop
1060 :
1070 PRINT\'Second pass'\
1080 pass=1
1090 REPeat pass2
1100   obj$=''
1110   lab$=''
1120   REPeat lp
1130     line$=read_line$
1140     whole_line$=line$
1150     fld$=nxt_fld$(line$)
1160     IF fld$<>'':EXIT lp
1170   END REPeat lp
1180   PRINT#channel;HEX$(pc,20)
1190   IF fld$='END':EXIT pass2
1200   IF fld$(1)='*':PRINT#channel;TO 27;whole_line$;:NEXT pass2
1210   IF fld$(LEN(fld$))=':' THEN
1220       lab$=fld$(TO LEN(fld$)-1)
1230       mnem$=nxt_fld$(line$)
1240       op$=nxt_fld$(line$)
1250     ELSE
1260       mnem$=fld$
1270       op$=nxt_fld$(line$)
1280   END IF
1290   IF op$='':op$='*'
1300   IF op$='*' THEN
1310       src$=''
1320       dest$=''
1330     ELSE
1340       IF cnt_ops(op$)=1 THEN
1350           src$=op$
1360           dest$=''
1370         ELSE
1380           src$=op1$(op$)
1390           dest$=op2$(op$)
1400       END IF
1410   END IF
1420   link=mnemonic$(mnem$)
1430   IF link>=56 THEN
1440       line$=op$
1450       pseudo_op lab$,mnem$,pc
1460       print_object(obj$)
1470       PRINT#channel;TO 27;whole_line$;
1480       NEXT pass2
1490   END IF
1500 :
1510   IF link=4 THEN
1520       evaluate mnem$,src$,'',link,src_type%,0
1530       prt_obj(obj$):PRINT#channel;TO 27;whole_line$;:PRINT#6;obj$
1540       NEXT pass2
1550   END IF
1560 :
1570 REMark evaluate source operand
1580 :
1590   src_type%=op_type(src$,mnem$,'s')
1600   IF src_type%=8 OR src_type%=9 THEN
1610       addr=fnd_sym(src$)
1620       IF addr=2^33 THEN
1630           ec%=ferror('undefined label - '&whole_line$,ec%)
1640           NEXT pass2
1650   END IF
1660       src$=addr
1670   END IF
1680 :
1690 REMark evaluate destination operand
1700 :
1710   IF dest$<>'' THEN
1720       dest_type%=op_type(dest$,mnem$,'d')
1730       IF dest_type%=8 OR dest_type%=9 THEN
1740           addr=fnd_sym(dest$)
1750           IF addr=2^33 THEN
1760               ec%=ferror('undefined label - '&whole_line$,ec%)
1770               NEXT pass2
1780           END IF
1790           dest$=addr
1800       END IF
1810     ELSE
1820       dest_type%=0
1830   END IF
1840 :
1850 REMark evaluate instruction & POKE into memory
1860 :
1870   evaluate mnem$,src$,dest$,link,src_type%,dest_type%
1880   prt_obj(obj$):PRINT#channel;TO 27;whole_line$;:PRINT#6;obj$
1890 END REPeat pass2
1892 PRINT#channel;\'First pass pc = ';HEX$(old_pc,20)
1895 PRINT#channel;CHR$(12):CLOSE#3
1900 CLOSE#6
1920 IF ec%>0 THEN
1930     display_errors ec%
1940     close_file file$
1950     STOP
1960 END IF
1970 :
2000 close_file file$
2010 STOP
2020 :
2170 DEFine PROCedure screen
2180   MODE 4
2185   CLS:CSIZE 2,1:PRINT TO 14;'QSNAIL'
2190   CSIZE 1,0:PRINT TO 17;' 1984 Giles Todd'\\
2200 END DEFine screen
2210 :
2220 DEFine FuNction file_prompt$
2230   LOCal filname$,lp,a$
2250   INPUT'Input filename?  ';file$
2260   INPUT'Output filename? ';outfile$
2280   INPUT'Send listing to? ';channel$
2310   IF channel$=='MDV' THEN DELETE channel$:OPEN_NEW#3;channel$:ELSE OPEN_NEW#3;channel$
2315   channel=3
2320   RETurn file$
2330 END DEFine file_prompt$
2340 :
2350 DEFine PROCedure open_file(f$)
2360   OPEN_IN#5;f$
2370 END DEFine open_file
2380 :
2390 DEFine FuNction read_line$
2400   LOCal line$,_get$,outlp,lp
2410   _get$=''
2420   line$=''
2430   REPeat outlp
2440     REPeat lp
2450       IF EOF(#5) THEN
2460           line$='END'
2470           EXIT lp
2480       END IF
2490       _get$=INKEY$(#5)
2500       IF CODE(_get$)=13 OR CODE(_get$)=10:EXIT lp
2510       line$=line$&_get$
2520     END REPeat lp
2530     IF pass=1 AND CODE(_get$)=10:PRINT#channel
2540     IF line$<>'':EXIT outlp
2550   END REPeat outlp
2560   RETurn line$
2570 END DEFine read_line$
2580 :
2590 DEFine PROCedure close_file(f$)
2600   CLOSE#5
2610 END DEFine close_file
2620 :
2630 DEFine FuNction nxt_fld$(l$)
2640   LOCal f$,i%,lp
2650   f$=''
2660   IF l$='':RETurn l$
2670   i%=0
2680   REPeat lp
2690     i%=i%+1
2700     IF l$(i%)<>' ' AND CODE(l$(i%))<>9:EXIT lp
2710     IF i%=LEN(l$):EXIT lp
2720   END REPeat lp
2730   IF i%=LEN(l$) AND (l$(i%)=' ' OR CODE(l$(i%))=9):RETurn ''
2740   REPeat lp
2750     f$=f$&l$(i%)
2760     IF i%=LEN(l$):EXIT lp
2770     i%=i%+1
2780   IF l$(i%)=' ' OR CODE(l$(i%))=9:EXIT lp
2790   END REPeat lp
2800   IF i%=LEN(l$) THEN l$='':ELSE l$=l$(i% TO)
2810   RETurn l$
2820 END DEFine nxt_fld$
2830 :
2840 DEFine PROCedure initialise_arrays
2850   LOCal i%
2870   max_sym=200
2880   DIM mnemonic$(63,5),sym$(max_sym,8),sym_addr(max_sym),condition$(15,2),cond%(15),word(15)
2900   RESTORE 3010
2910   FOR i%=0 TO 63
2920     READ mnemonic$(i%)
2930   END FOR i%
2940   FOR i%=0 TO 18
2950     READ sym$(i%)
2960   END FOR i%
2970   FOR i%=0 TO 15
2980     READ condition$(i%),cond%(i%)
2990   END FOR i%
3000 END DEFine initialise_arrays
3010 DATA 'ADD','AND','ASL','ASR','Bcc','BRA','BSR','CLR','CMP','EOR','JMP','JSR','LSL','LSR','MOVE','OR','ROL','ROR','RTS','SUB'
3020 DATA 'ABCD','BTST','DBcc','EXG','MOVEM','MOVEP','MULS','MULU','NEG','NOP','NOT','ROXL','ROXR','RTE','RTR','SBCD','STOP','SWAP','TST'
3030 DATA 'BCHG','BCLR','BSET','CHK','DIVS','DIVU','EXT','LEA','LINK','NBCD','PEA','RESET','Scc','TAS','TRAP','TRAPV','UNLK'
3040 DATA 'ORG','END','EQU','SET','REG','DC','DCB','DS'
3050 DATA 'D0','D1','D2','D3','D4','D5','D6','D7','A0','A1','A2','A3','A4','A5','A6','A7','PC','CCR','SR'
3060 DATA 'CC',4,'CS',5,'EQ',7,'F',1,'GE',12,'GT',14,'HI',2,'LE',15,'LS',3,'LT',13,'MI',11,'NE',6,'PL',10,'T',0,'VC',8,'VS',9
3070 :
3080 DEFine FuNction fnd_sym(op$)
3090   LOCal i%,addr
3100   i%=-1
3110   REPeat lp
3120     i%=i%+1
3130     IF op$(TO 8)=sym$(i%) THEN
3140         addr=sym_addr(i%)
3150         EXIT lp
3160     END IF
3170     IF i%=max_sym THEN
3180         addr=2^33
3190         EXIT lp
3200     END IF
3210   END REPeat lp
3220   RETurn addr
3230 END DEFine fnd_sym
3240 :
3250 DEFine PROCedure add_sym(f$,pc)
3260   LOCal i%
3270   i%=-1
3280   REPeat lp
3290     i%=i%+1
3300     IF sym$(i%)='' THEN
3310         sym$(i%)=f$
3320         sym_addr(i%)=pc
3330         EXIT lp
3340     END IF
3350     IF i%>max_sym THEN
3360         ec%=ferror(f$&' - too many symbols',ec%)
3370         EXIT lp
3380     END IF
3390   END REPeat lp
3400 END DEFine add_sym
3410 :
3420 DEFine FuNction mnemonic(f$)
3430   LOCal i%,j,s$,index,t$
3440   index=-1
3450   t$=f$
3460   s$=t$(LEN(t$)-1 TO)
3470   IF s$='.B' OR s$='.W' OR s$='.L' THEN
3480       t$=t$(TO LEN(t$)-2)
3490   END IF
3500   s$=t$(LEN(t$))
3510   IF (s$='I' AND t$<>'BHI' AND t$<>'SHI' AND t$<>'DBHI' AND t$<>'BMI' AND t$<>'SMI' AND t$<>'DBMI') OR (s$='A' AND t$<>'DBRA' AND t$<>'BRA' AND t$<>'LEA' AND t$<>'PEA') OR s$='X' OR (s$='Q' AND t$<>'DBEQ' AND t$<>'BEQ' AND t$<>'SEQ') OR (s$='M' AND t$<>'CMPM') THEN
3520       t$=t$(TO LEN(t$)-1)
3530   END IF
3540   FOR i%=0 TO 63
3550     IF t$=mnemonic$(i%):index=i%:EXIT i%
3560     IF mnemonic$(i%)='Bcc' OR mnemonic$(i%)='DBcc' OR mnemonic$(i%)='Scc' THEN
3570         IF f$='DBRA'THEN f$='DBF':t$=f$
3580         s$=mnemonic$(i%)
3590         s$=s$(TO LEN(s$)-2)
3600         FOR j=0 TO 15
3610           IF f$(TO LEN(s$)&condition$(j))=s$&condition$(j) AND LEN(t$)=LEN(s$&condition$(j)) THEN
3620               index=i%
3630               EXIT j
3640           END IF
3650         END FOR j
3660         IF index<>-1:EXIT i%
3670     END IF
3680   END FOR i%
3690   RETurn index
3700 END DEFine mnemonic
3710 :
3720 DEFine FuNction ferror(ferror$,ec%)
3730   LOCal i%
3740   BEEP 8132,128
3750   PRINT#channel;ferror$
3760   i%=ec%+1
3770   RETurn i%
3780 END DEFine ferror
3790 :
3800 DEFine PROCedure pseudo_op(l$,f$,pc)
3810   LOCal t$,tmp_addr,i%,len%,mask,giles
3820   IF f$='ORG' THEN
3830       t$=nxt_fld$(line$)
3840       tmp_addr=eval(t$)
3850       IF tmp_addr=2^33 THEN
3860           ec%=ferror(whole_line$&' - operand not defined', ec%)
3870       END IF
3880       pc=tmp_addr
3890   END IF
3900   IF f$='END' THEN
3910       pc=pc+0
3920   END IF
3930   IF f$='EQU' THEN
3940       t$=next_field$(line$)
3950       tmp_addr=eval(t$)
3960       IF tmp_addr=2^33 THEN
3970           ec%=ferror(whole_line$&' - operand not defined',ec%)
3980       END IF
3990       change_symbol lab$,tmp_addr
4000       pc=pc+0
4010       obj$=cvs$(tmp_addr,4)
4020   END IF
4030   IF f$='SET' THEN
4035       PRINT'SET not implemented'
4040       pc=pc+2
4050   END IF
4060   IF f$='REG' THEN
4070       PRINT'REG not implemented'
4080       pc=pc+0
4090   END IF
4100   IF f$='DCB.B' OR f$='DCB.W' OR f$='DCB.L' OR f$='DCB' THEN
4110       PRINT'DCB not implemented'
4120       pc=pc+0
4130   END IF
4140   IF f$='DC.B' OR f$='DC.W' OR f$='DC.L' OR f$='DC' THEN
4150       len%=2-(f$(3 TO)='.B')+2*(f$(3 TO)='.L')
4160       tmp_addr=0
4170       t$=next_field$(line$)
4180       obj$=''
4190       REPeat giles
4200         i%=',' INSTR t$
4210         IF i%=0 THEN
4220             IF pass=1 AND eval(t$)=2^33:operr
4230             obj$=obj$&cvs$(eval(t$),len%)
4240             tmp_addr=tmp_addr+1:EXIT giles
4250           ELSE
4260             IF pass=1 AND eval(t$(TO i%-1))=2^33:operr
4270             obj$=obj$&cvs$(eval(t$(TO i%-1)),len%)
4280             t$=t$(i%+1 TO)
4290             tmp_addr=tmp_addr+1
4300         END IF
4310       END REPeat giles
4320       pc=pc+tmp_addr
4330       IF pass:PRINT#6;obj$
4340   END IF
4350   IF f$='DC.B' OR f$='DC.W' OR f$='DC.L' OR f$='DC' THEN
4360       tmp_addr=eval(nxt_fld$(line$))
4370       IF f$='DS' THEN
4380           pc=pc+tmp_addr*2
4390           obj$=FILL$(CHR$(0),tmp_addr*2)
4400         ELSE
4410           pc=pc+tmp_addr*((f$='DS.B')+(f$='DSW')*2+(f$='DSL')*4)
4420           obj$=FILL$(CHR$(0),tmp_addr*((f$='DS.B')+(f$='DSW')*2+(f$='DSL')*4))
4430       END IF
4440       IF pass:PRINT#6;obj$
4450   END IF
4460 END DEFine pseudo_op
4670 :
4680 DEFine FuNction eval(t$)
4690   LOCal result
4700   result=2^33
4710   IF t$='':RETurn result
4720   IF t$='*':RETurn pc
4730   IF '[' INSTR t$:RETurn expression(t$)
4740   IF t$(1)='#':t$=t$(2 TO)
4750   IF t$(1)="'":result=CODE(t$(2))
4760   IF (t$(1)>='0' AND t$(1)<='9') OR t$='-' THEN
4770       result=t$
4780   END IF
4790   IF t$(1)='$' THEN
4800       result=HEX(t$(2 TO))
4810   END IF
4820   IF result=2^33 THEN
4830       IF LEN(t$)>8:t$=t$(TO 8)
4840       result=fnd_sym(t$)
4850   END IF
4860   RETurn result
4870 END DEFine eval
4880 :
4890 DEFine PROCedure chng_sym(lab$,addr)
4900   LOCal i%
4910   FOR i%=0 TO max_sym
4920     IF lab$(TO 8)=sym$(i%) THEN
4930         sym_addr(i%)=addr
4940         EXIT i%
4950     END IF
4960   END FOR i%
4970 END DEFine chng_sym
4980 :
4990 DEFine FuNction cnt_ops(op$)
5000   LOCal result,i%,outlp,lp
5010   IF op$='':RETurn 0
5020   result=1:i%=0
5030   REPeat outlp
5040     i%=i%+1
5050     IF i%>LEN(op$):EXIT outlp
5060     IF op$(i%)=',' THEN
5070         result=2
5080         EXIT outlp
5090     END IF
5100     IF op$='(' THEN
5110         REPeat lp
5120           i%=i%+1
5130           IF i%>LEN(op$) THEN
5140               result=0
5150               EXIT lp
5160           END IF
5170           IF op$(i%)=')':EXIT lp
5180         END REPeat lp
5190     END IF
5200     IF result=0:EXIT outlp
5210   END REPeat outlp
5220   RETurn result
5230 END DEFine cnt_ops
5240 :
5250 DEFine FuNction op1$(op$)
5260   LOCal i%,t,lp,outlp
5270   i%=0:t$=''
5280   REPeat outlp
5290     i%=i%+1
5300     IF op$(i%)=',':EXIT outlp
5310     t$=t$&op$(i%)
5320     IF op$(i%)='(' THEN
5330         REPeat lp
5340           i%=i%+1
5350           t$=t$&op$(i%)
5360           IF op$(i%)=')':EXIT lp
5370         END REPeat lp
5380     END IF
5390   END REPeat outlp
5400   RETurn t$
5410 defdef op1$
5420 :
5430 DEFine FuNction op2$(op$)
5440   LOCal i%,t,lp
5450   i%=0:t$=''
5460   i%=LEN(op1$(op$))
5464           IF (t>=-32768 AND t<=32767 AND NOT inside('.L',fld$)) OR inside('.W',fld$) OR inside('.B' ,fld$) THEN
5470   i%=i%+1:REMark avoid comma
5480   REPeat lp
5490     i%=i%+1
5500     IF i%>LEN(op$):EXIT lp
5510     t$=t$&op$(i%)
5520   END REPeat lp
5530   RETurn t$
5540 END DEFine op2$
5550 :
5560 DEFine FuNction op_type(op$,fld$,sd$)
5570   LOCal i%,result,t,t$
5580   result=0
5590   IF op$='CCR' OR op$='SR' OR op$='USP':RETurn result
5600   IF cnt_ops(op$)=0:RETurn result
5610   IF LEN(op$)>1 AND NOT '(' INSTR op$ THEN
5620       t=eval(op$(2 TO))
5630       IF op$(1)='#' THEN
5640           IF (t>=-32768 AND t<=32767 AND NOT inside('.L',fld$)) OR inside('.W',fld$) OR inside('.B' ,fld$) THEN
5650               result=12
5660             ELSE
5670               result=13
5680           END IF
5690       END IF
5700   END IF
5710   IF result<>0:RETurn result
5720   FOR i%=0 TO 7
5730     IF op$=symbol$(i%) THEN
5740         result=1
5750         EXIT i%
5760     END IF
5770   END FOR i%
5780   IF 'MOVEM' INSTR fld$:result=0
5790   IF result<>0:RETurn result
5800   FOR i%=8 TO 15
5810     IF op$=sym$(i%) THEN
5820         result=2
5830         EXIT i%
5840     END IF
5850   END FOR i%
5860   IF 'MOVEM' INSTR fld$:result=0
5870   IF result<>0:RETurn result
5880   FOR i%=8 TO 15
5890     IF op$='('&symbol$(i%)&')' THEN
5900         result=3
5910         EXIT i%
5920     END IF
5930   END FOR i%
5940   IF result<>0:RETurn result
5950   FOR i%=8 TO 15
5960     IF op$='('&sym$(i%)&')+' THEN
5970         result=4
5980         EXIT i%
5990     END IF
6000   END FOR i%
6010   IF result<>0:RETurn result
6020   FOR i%=8 TO 15
6030     IF op$='-('&sym$(i%)&')' THEN
6040         result=5
6050         EXIT i%
6060     END IF
6070   END FOR i%
6080   IF result<>0:RETurn result
6090   IF '(A' INSTR op$ THEN
6100       FOR i%=8 TO 15
6110         IF op$(LEN(op$)-3 TO)='('&sym$(i%)&')':result=6:EXIT i%
6120       END FOR i%
6130   END IF
6140   IF result<>0:RETurn result
6150   IF '(A' INSTR op$ AND ',' INSTR op$ AND ')' INSTR op$:result=7
6160   IF result<>0:RETurn result
6170   IF '(PC)' INSTR op$ THEN
6180       result=10
6190   END IF
6200   IF result<>0:RETurn result
6210   IF '(PC,' INSTR op$ THEN
6220       result=11
6230   END IF
6240   IF result<>0:RETurn result
6280   t=eval(op$)
6290   IF (t>=0 AND t<=HEX('7FFF')) OR (t>=HEX('80000') AND t<=HEX('FFFFF')) THEN
6300       result=8
6310       result=9
6320     ELSE
6330   END IF
6340   IF fld$(TO 5)='MOVEM' AND ('/' INSTR op$ OR '-' INSTR op$ OR reg(op$,0)<>-1):result=16
6350   IF result<>0:result=9
6360   RETurn result
6370 END DEFine op_type
6380 :
6390 DEFine FuNction overhead(type,f$,s$)
6400   IF f$='MOVEQ':RETurn 0
6410   SELect ON type
6420     =1 TO 5:
6430        RETurn 0
6440     =6 TO 8:
6450        RETurn 2
6460     =9:
6470        RETurn 4
6480     =10 TO 12:
6490        RETurn 2
6500     =12:
6510        IF f$(TO 2)='LS' OR f$(TO 2)='AS' OR f$(TO 2)='RO' OR f$='TRAP' OR 'Q' INSTR f$ THEN RETurn 0:ELSE RETurn 2
6520    =13:
6522        IF '.W' INSTR f$ OR '.B' INSTR f$:RETurn 2
6530        IF 'Q' INSTR f$ THEN RETurn 0:ELSE RETurn 4
6540    =16:
6550        RETurn 2
6560    =REMAINDER
6570        RETurn 0
6580   END SELect
6590 END DEFine overhead
6600 :
6610 DEFine FuNction short_branch(f$,link,op$)
6620   IF link<4 OR link>6:RETurn 0
6630   IF f$(LEN(f$)-1 TO)='.S':RETurn 1
6640   IF eval(op$)-pc<-126 OR eval(op$)-pc>129:RETurn 0
6650   RETurn 1
6660 END DEFine short_branch
6670 :
6680 DEFine FuNction branch(f$,link)
6690   IF link<4 OR link>6 THEN
6700       RETurn 0
6710     ELSE
6720       RETurn 1
6730   END IF
6740 END DEFine branch
6750 :
6760 DEFine PROCedure reset_pointer(f$)
6770   close_file f$
6780   open_file f$
6790   DELETE outfile$
6800   OPEN_NEW#6;outfile$
6810 END DEFine reset_pointer
6820 :
6830 DEFine PROCedure prt_obj(o$)
6840   LOCal i%,j,t$
6850   IF o$='' THEN
6860       RETurn
6870     ELSE
6880       IF LEN(o$)>10 THEN j=10:ELSE j=LEN(o$)
6890       PRINT#channel;' ';
6900       FOR i%=1 TO j
6910         t$=HEX$(CODE(o$(i%)),8)
6920         IF LEN(t$)=1:t$='0'&t$
6930         PRINT#channel;t$;
6940       END FOR i%
6950   END IF
6960 END DEFine prt_obj$
6970 :
6980 DEFine FuNction cvs$(num,len%)
6990   LOCal byte%(3),t$
7000   byte%(0)=DIV_L(num,2^24)
7010   byte%(1)=DIV_L(MOD_L(num,2^24),2^16)
7020   byte%(2)=DIV_L(MOD_L(num,2^16),2^8)
7030   byte%(3)=MOD_L(num,2^8)
7040   t$=''
7050   t$=t$&CHR$(byte%(0))
7060   t$=t$&CHR$(byte%(1))
7070   t$=t$&CHR$(byte%(2))
7080   t$=t$&CHR$(byte%(3))
7090   RETurn t$(5-len% TO)
7100 END DEFine cvs$
7110 :
7120 DEFine PROCedure evaluate(mn$,src$,dest$,link,stype,dtype)
7121   regd%=reg(dest$,dtype)
7122   regs%=reg(src$,stype)
7123   amoded%=amode%(dtype)
7124   amodes%=amode%(stype)
7130   SELect ON link
7140     =0
7150      link0
7160     =1
7170      link1
7180     =2
7190      link2
7200     =3
7210      link3
7220     =4
7230      link4
7240     =5
7250       IF mn$(LEN(mn$)-1 TO)='.S' THEN mn$='BT .S':ELSE mn$='BT'
7260      link4
7270     =6
7280      link6
7290     =7
7300      link7
7310     =8
7320      link8
7330     =9
7340      link9
7350     =10
7360      link10
7370     =11
7380      link11
7390     =12
7400      link12
7410     =13
7420      link13
7430     =14
7440      link14
7450     =15
7460      link15
7470     =16
7480      link16
7490     =17
7500      link12
7510     =18
7520      link18
7530     =19
7540      link0
7550     =20
7560      link20
7570     =21
7580      link21
7590     =22
7600      IF mn$='DBRA':mn$='DBF'
7610      link4
7620     =23
7630      link23
7640     =24
7650      link24
7660     =25
7670      link25
7680     =26
7690      link26
7700     =27
7710      link27
7720     =28
7730      link28
7740     =29
7750      link29
7760     =30
7770      link30
7780     =31
7790      link31
7800     =32
7810      link32
7820     =33
7830      link33
7840     =34
7850      link34
7860     =35
7870      link35
7880     =36
7890      link36
7900     =37
7910      link37
7920     =38
7930      link38
7940     =39
7950      link39
7960     =40
7970      link40
7980     =41
7990      link41
8000     =42
8010      link42
8020     =43
8030      link43
8040     =44
8050      link44
8060     =45
8070      link45
8080     =46
8090      link46
8100     =47
8110      link47
8120     =48
8130      link48
8140     =49
8150      link49
8160     =50
8170      link50
8180     =51
8190      link51
8200     =52
8210      link52
8220     =53
8230      link53
8240     =54
8250      link54
8260     =55
8270      link55
8280   END SELect
8290 END DEFine evaluate
8300 :
8310 DEFine PROCedure link14
8320   LOCal i%,t$,len%
8330   IF dest$='CCR' OR src$='SR' OR dest$='SR' OR src$='USP' OR src$='USP':status_:RETurn
8340   IF mn$(LEN(mn$))='Q' THEN
8350       IF dtype<>1:operr
8370       word(0)=HEX('7000')+regd%*HEX('200')+INT(eval(src$))&&255
8390       len%=2
8400     ELSE
8410       SELect ON dtype=10 TO 16:operr
8420       SELect ON t$
8430         ='.B':IF stype=2:operr
8440               word(0)=HEX('1000')
8450         ='.L':word(0)=HEX('2000')
8460         ='.W':word(0)=HEX('3000')
8470       END SELect
8480       word(0)=word(0)+regd%*HEX('200')+amoded%*HEX$('40')+amodes%*HEX('8')+regs%
8570       len%=2+overhead(stype,mn$,src$)+overhead(dtype,mn$,dest$)
8580   END IF
8590   IF mn$(LEN(mn$))<>'Q' THEN opcode:ELSE obj$=cvs$(word(0),2)
8600   pc=pc+len%:REMark poke the code here
8610 END DEFine link14
8620 :
8630 DEFine FuNction reg(r$,type)
8640   LOCal i%,j,t$,notfound
8650   IF type=13:RETurn 4
8660   IF type>7:RETurn type-8
8670   IF type=7:i%=r$(('(A' INSTR r$)+2):RETurn i%
8680   notfound=-1
8690   FOR j=0 TO 7
8700     IF 'A'&j INSTR r$ OR 'D'&j INSTR r$ THEN
8710         notfound=j
8720         EXIT j
8730     END IF
8740   END FOR j
8750   RETurn notfound
8780 END DEFine reg
8790 :
8880 DEFine PROCedure opcode(r$,type)
8890   LOCal a$
8900   obj$=cvs$(word(0),2)
8910   IF stype=8 OR (stype=12 AND NOT 'Q' INSTR mn$):word(1)=eval(src$):obj$=obj$&cvs$(word(1),2)
8920   IF stype=9 OR (stype=13 AND NOT 'Q' INSTR mn$):i%=eval(src$):word(1)=DIV_L(i%,65536):word(2)=MOD_L(i%,65536):obj$=obj$&cvs$(word(1),2)&cvs$(word(2),2)
8930   IF stype=7 OR stype=11 THEN
8940       word(1)=eval(src$(TO '(' INSTR src$-1))&&255+reg(src$(',' INSTR src$+1 TO ',' INSTR src$+2,0))*HEX('1000')
8950       IF '.L' INSTR src$ THEN word(1)=word(1)+HEX('800')
8960       IF ',A' INSTR src$ THEN word(1)=word(1)+HEX('8000')
8970       obj$=obj$&cvs$(word(1),2)
8980   END IF
8990   IF stype=6:word(1)=eval(src$(TO '(' INSTR src$-1)):obj$=obj$&cvs$(word(1),2)
9000   IF stype=10:pcrel(src$):obj$=obj$&cvs$(word(1),2)
9010   IF dest$<>'':IF dtype=8 OR dtype=12 THEN word(1)=eval(dest$):obj$=obj$&cvs$(word(1),2)
9020   IF dest$<>'':IF dtype=9 OR dtype=13:i%=eval(dest$):word(1)=DIV_L(i%,65536):word(2)=MOD_L(i%/65536):obj$=obj$&cvs$(word(1),2)&cvs$(word(2),2)
9030   IF dtype=7 THEN
9040       word(1)=eval(dest$(TO '(' INSTR dest$-1))&&255+reg(dest$(',' INSTR dest$+1 TO ',' INSTR dest$+2,0))*HEX('1000')
9050       IF '.L' INSTR dest$:word(1)=word(1)+HEX('800')
9060       IF ',A' INSTR dest$:word(1)=word(1)+HEX('8000')
9070       obj$=obj$&cvs$(word(1),2)
9080   END IF
9090   IF dtype=6:word(1)=eval(dest$(TO '(' INSTR dest$-1)):obj$=obj$&cvs$(word(1),2)
9100   IF dtype=10:pcrel(dest$):obj$=obj$&cvs$(word(1),2)
9110 END DEFine opcode
9120 :
9130 DEFine PROCedure pcrel(op$)
9140   LOCal t
9150   IF op$(1)='#' THEN
9160       t=eval(op$(TO '(' INSTR op$-1))
9170     ELSE
9180       t=eval(op$(TO '(' INSTR op$-1))-(pc+2)
9190   END IF
9195   IF t<-32768 OR t>32767:operr
9200   word(1)=t
9210 END DEFine pcrel
9220 :
9230 DEFine PROCedure link4
9240   LOCal sht,t$,p_c,disp,i%
9250   sht=0
9260   t$=mn$
9270   IF mn$(LEN(mn$)-1 TO)='.S' THEN
9280       sht=1
9290       t$=mn$(TO LEN(mn$)-2)
9300   END IF
9310   word(0)=HEX('6000'):IF mn$(1)='D' THEN word(0)=HEX('50C8')+regs%
9320   IF t$(1)='D':t$=t$(2 TO)
9330   FOR i%=0 TO 15
9340     IF condition$(i%)=t$(2 TO) THEN
9350         word(0)=word(0)+cond%(i%)*HEX('100')
9360         EXIT i%
9370     END IF
9380   END FOR i%
9390   p_c=pc
9400   IF sht OR mn$(1)='D' THEN
9410       p_c=p_c+2
9420     ELSE
9430       p_c=p_c+4
9440   END IF
9470   IF sht THEN
9480       p_c=pc+2
9490       word(0)=word(0)+disp+256*(disp<0)
9540     ELSE
9550       word(1)=disp
9560   END IF
9565   IF sht=1 AND (disp<-128 OR disp>127):operr
9570   obj$=cvs$(word(0),2):IF NOT sht:obj$=obj$&cvs$(word(1),2)
9580   IF mn$='D':p_c=p_c+2
9590   pc=p_c
9600 END DEFine link4
9610 :
9620 DEFine PROCedure link38
9630   LOCal i%,t$,len%
9640   SELect ON stype=2,10 TO 16:operr
9650   word(0)=HEX('4A00')
9660   t$=mn$(LEN(mn$)-1 TO)
9670   IF t$='.L':word(0)=word(0)+HEX('80')
9680   IF t$<>'.L' OR t$<>'.B':word(0)=word(0)+HEX('40')
9690   word(0)=word(0)+amodes%*HEX('8')+regs%
9700   len%=2+overhead(stype,mn$,src$)
9710   opcode
9720   pc=pc+len%
9730 END DEFine link38
9740 :
9750 DEFine PROCedure link0
9760   LOCal i%,t$,len%,size%,_add%,_sub%,_size%
9770   sizetemp
9771   IF mn$='ADD':_add%=HEX('D000')
9772   IF mn$='SUB':_sub%=HEX('9000')
9775       _size%=size%*HEX('40')
9780   IF NOT(t$(i%)INSTR 'AIQX') THEN
9790       IF mn$(TO 3)='ADD':word(0)=_add%+_size%
9795       IF mn$(TO 3)='SUB':word(0)=_sub%+_size%
9800       IF stype=1 AND dtype<>1 AND dtype<>2 THEN
9810           SELect ON dtype=2,10 TO 16:operr
9820           word(0)=word(0)+regs%*HEX('200')+amodes%*HEX('8')+regd%
9830         ELSE
9840           SELect ON dtype=3 TO 16:operr
9850           word(0)=word(0)+reg%*HEX('200')+amoded%*HEX('8')+regs%
9860       END IF
9870       len%=2+overhead(stype,mn$,src$)+overhead(dtype,mn$,dest$)
9880   END IF
9890   IF t$(i%)='A' THEN
9900       SELect ON dtype=2,10 TO 16:operr
9910       IF mn$(TO 3)='ADD':word(0)=_add%+regd%*HEX('200')+amodes%*HEX('8')+regs%
9915       IF mn$(TO 3)='SUB':word(0)=_sub%+regd%*shift(9)+amodes%*HEX('8')+regs%
9920       IF size%=2:word(0)=word(0)+HEX('100')
9930       len%=2+overhead(stype,mn$,src$)
9940   END IF
9950   IF t$(i%)='I' OR ((stype=12 OR stype=13) AND t$(i%)<>'Q' AND t$(i%)<>'A') THEN
9960       SELect ON stype=1 TO 11,14 TO 16:operr
9970       SELect ON dtype=2,10 TO 16:operr
9990       len%=2+overhead(stype,mn$,src$)+overhead(dtype,mn$,dest$)
10000   END IF
10010   IF t$(i%)='Q' THEN
10020       SELect ON stype=1 TO 11,14 TO 16:operr
10030       SELect ON dtype=10 TO 16:operr
10040       len%=eval(src$):IF len%=8:len%=0
10050       IF mn$='ADD':word(0)=HEX('5000')+len%*HEX('200')+_size%+amoded%*HEX('8')+regd%
10051       IF mn$='SUB':word(0)=HEX('5100')+len%*HEX('200')+_size%+amoded%*HEX('8')+regd%
10060       len%=2+overhead(dtype,mn$,dest$)
10070   END IF
10080   IF t$(i%)='X' THEN
10090       IF NOT(stype=1 AND dtype=1) OR NOT(stype=5 AND dtype=5):operr
10100       IF mn$='ADD':word(0)=_add%+regd%*HEX('200')+_size%+regs%
10101       IF mn$='SUB':word(0)=_sub%+regd%*HEX('200')+_size%+regs%
10110       IF stype=5 AND dtype=5:word(0)=word(0)+HEX('8')
10120       len%=2
10130   END IF
10140   IF len%=2:obj$=cvs$(word(0),2):ELSE opcode
10150   pc=pc+len%
10160 END DEFine link0
10170 :
10180 DEFine PROCedure link18
10190   word(0)=HEX('4E75')
10200   obj$=cvs$(word(0),2)
10210   pc=pc+2
10220 END DEFine link18
10230 :
10240 DEFine PROCedure link8
10250   LOCal t$,size%,len%,i%,_size%
10260   sizetemp
10265   _size%=size%*HEX('40')
10270   IF NOT(t$(i%) INSTR 'AIM') THEN
10280       SELect ON dtype=3 TO 16:operr
10290       word(0)=HEX('B000')+regd%*HEX('200')+amodes%*HEX('8')+regs%
10300       len%=2+overhead(stype,mn$,src$)
10310   END IF
10320   IF t$(i%)='A' THEN
10330       SELect ON dtype=1,3 TO 16:operr
10340       word(0)=HEX('B0C0')+regd%*HEX('200')+amodes%*HEX('8')+regs%
10350       IF size%=2:word(0)=word(0)+HEX('100')
10360       len%=2+overhead(stype,mn$,src$)
10370   END IF
10380   IF t$(i%)='I' OR ((stype=12 OR stype=13) AND t$(i%)<>'A') THEN
10390       SELect ON dtype=2,10 TO 16:operr
10400       SELect ON stype=1 TO 11,14 TO 16:operr
10410       word(0)=HEX('C00')+_size%+amoded%*HEX('8')+regd%
10420       len%=2+overhead(stype,mn$,src$)+overhead(dtype,mn$,dest$)
10430   END IF
10440   IF t$(i%)='M' THEN
10450       IF stype<>4 OR dtype<>4:operr
10460       word(0)=HEX('B100')+regd%*HEX('200')+_size%+HEX('8')+regs%
10470       len%=2
10480   END IF
10490   opcode
10500   pc=pc+2
10510 END DEFine link8
10520 :
10530 DEFine PROCedure link12
10540   LOCal i%,len%,size%,t$
10550   sizetemp
10560   IF dest$='' THEN
10570       SELect ON stype=1,2,10 TO 16:operr
10580       word(0)=HEX('E1C0')+amodes%*HEX('8')+regs%
10590       IF t$='ROR':word(0)=word(0)+HEX('300')
10600       len%=2+overhead(stype,mn$,dest$)
10610       opcode
10620     ELSE
10630       word(0)=HEX('E108')
10640       IF stype=12 THEN
10650           IF dtype<>1:operr
10660           i%=eval(src$) MOD 8
10680           word(0)=word(0)+i%*HEX('200')
10690         ELSE
10700           IF stype<>1 OR dtype<>1:operr
10710           word(0)=word(0)+regs%*HEX('200')+shift(5)
10720       END IF
10730       word(0)=word(0)+size%*HEX('40')+regd%
10740       IF t$='ROR':word(0)=word(0)-HEX('F0')
10750       len%=2
10760       obj$=cvs$(word(0),2)
10770   END IF
10780   pc=pc+len%
10790 END DEFine link12
10800 :
10810 DEFine PROCedure link21
10820   LOCal i%,len%,size%,t$
10830   sizetemp
10840   SELect ON stype=2 TO 11,13 TO 16:operr
10850   SELect ON dtype=2,12 TO 16:operr
10860   IF stype=1 THEN
10870       word(0)=HEX('100')+regs%*HEX('200')
10880     ELSE
10890       word(0)=HEX('8000')
10900   END IF
10910   word(0)=word(0)+amoded%*HEX('8')+regd%
10920   len%=2+overhead(stype,mn$,src$)+overhead(dtype,mn$,dest$)
10930   opcode
10940   pc=pc+len%
10950 END DEFine link21
10960 :
10970 DEFine PROCedure sizetemp
10980   t$=mn$(LEN(mn$)-1 TO)
10990   IF t$='.B':size%=0
11000   IF t$='.L':size%=2
11010   IF t$='.W' OR (t$<>'.B' AND t$<>'.W' AND t$<>'.L'):size%=1
11020   IF t$='.W' OR t$='.B' AND t$='.L' THEN
11021       t$=mn$(TO LEN(mn$)-2)
11022     ELSE
11023       t$=mn$
11024   END IF
11030   i%=LEN(t$)
11040 END DEFine sizetemp
11050 :
11060 DEFine PROCedure link41
11070   LOCal i%,len%,size%,t$
11080   sizetemp
11090   SELect ON stype=2 TO 11,13 TO 16:operr
11100   SELect ON dtype=2,10 TO 16:operr
11110   IF stype=1 THEN
11120       word(0)=HEX('1C0')+regs%*HEX('200')
11130     ELSE
11140       word(0)=HEX('8C0')
11150   END IF
11160   word(0)=word(0)+amoded%*HEX('8')+regd%
11170   len%=2+overhead(word(0),2)
11180   opcode
11190   pc=pc+len%
11200 END DEFine link41
11210 :
11220 DEFine PROCedure link30
11230   LOCal i%,len%,size%,t$
11240   sizetemp
11250   SELect ON stype=2,10 TO 16:operr
11260   word(0)=HEX('4600')+size%*HEX('40')+amodes%*HEX('8')+regs%
11270   len%=2+overhead(stype,mn$,src$)
11280   opcode
11290   pc=pc+2
11300 END DEFine link30
11310 :
11320 DEFine FuNction inside(s$,f$)
11330   IF s$ INSTR f$ THEN RETurn 1:ELSE RETurn 0
11340 END DEFine inside
11350 :
11360 DEFine PROCedure link7
11370   LOCal i%,len%,size%,t$
11380   sizetemp
11390   SELect ON stype=2,10 TO 16:operr
11400   word(0)=HEX('4200')+size%*HEX('40')+amodes%*HEX('8')+regs%
11410   len%=2+overhead(stype,mn$,src$)
11420   opcode
11430   pc=pc+len%
11440 END DEFine link7
11450 :
11460 DEFine PROCedure link45
11470   LOCal i%,len%,size%,t$
11480   IF stype<>1:operr
11490   word(0)=HEX('4800')
11500   IF '.L' INSTR mn$ THEN
11510       size%=3
11520     ELSE
11530       size%=2
11540   END IF
11550   word(0)=word(0)+size%*HEX('40')+regs%
11560   obj$=cvs$(word(0),2)
11570   len%=2
11580   pc=pc+len%
11590 END DEFine link45
11600 :
11610 DEFine PROCedure link23
11620   SELect ON stype=3 TO 16:operr
11630   SELect ON dtype=3 TO 16:operr
11640   word(0)=12*shift(12)+shift(8)
11650   IF stype=1 AND dtype=1 THEN
11660       word(0)=word(0)+regs%*HEX('240')+regd%
11670   END IF
11680   IF stype=2 AND dtype=2 THEN
11690       word(0)=word(0)+regs%*HEX('200')+HEX('48')+regd%
11700   END IF
11710   IF stype=1 AND dtype=2 THEN
11720       word(0)=word(0)+regs%*HEX('200')+HEX('88')+regd%
11730   END IF
11740   IF stype=2 AND dtype=1 THEN
11750       word(0)=word(0)+regs%*HEX('200')+HEX('88')+regd%
11760   END IF
11770   obj$=cvs$(word(0),2)
11780   pc=pc+2
11790 END DEFine link23
11800 :
11810 DEFine PROCedure link27
11820   LOCal len%
11830   SELect ON stype=2,14 TO 16:operr
11840   SELect ON dtype=2 TO 16:operr
11850   word(0)=HEX('C0C0')+regd%*HEX('200')+amodes%*HEX('8')+regs%
11860   len%=2+overhead(stype,mn$,src$)
11870   opcode
11880   pc=pc+len%
11890 END DEFine link27
11900 :
11910 DEFine PROCedure _status
11920   LOCal len%
11925   word(0)=HEX('4040')
11930   IF dest$='CCR' THEN
11940       word(0)=word(0)+HEX('480')+amodes%*HEX('8')+regs%
11941       IF dest$='SR' THEN
11942           word(0)=word()+HEX('200')
11943       END IF
11950       len%=2+overhead(stype,mn$,src$)
11960       opcode
11970   END IF
12030   IF src$='SR' THEN
12040       word(0)=word(0)+HEX('80')+amoded%+regd%
12050       len%=2+overhead(dtype,mn$,dest$)
12060       opcode
12070   END IF
12080   IF src$='USP' OR dest$='USP' THEN
12090       word(0)=word(0)+HEX('E20')
12100       IF src$='USP':word(0)=word(0)+HEX('8')+regd%
12110       IF dest$='USP':word(0)=word(0)+regs%
12120       len%=2
12130       obj$=cvs$(word(0),2)
12140   END IF
12150   pc=pc+len%
12160 END DEFine _status
12170 :
12180 DEFine PROCedure link20
12190   LOCal len%
12200   IF NOT(stype=1 AND dtype=1) AND NOT(stype=5 AND dtype=5):operr
12210   word(0)=HEX('C100')+(stype=5)*HEX('8')+regd%*HEX('200')+regs%
12220   len%=2
12230   obj$=cvs$(word(0),2)
12240   pc=pc+len%
12250 END DEFine link20
12260 :
12270 DEFine PROCedure link1
12280   LOCal i%,len%,size%,t$
12290   sizetemp
12300   IF t$(i%)='I' OR stype=12 OR stype=13 THEN
12310       IF stype<>12 AND stype<>13:operr
12320       SELect ON dtype=2,10 TO 16:operr
12330       word(0)=HEX('200')+size%*HEX('40')
12340       IF dest$='SR' THEN
12350           word(0)=word(0)+HEX('3C')
12360         ELSE
12370           word(0)=word(0)+amoded%*HEX('8')+regs%
12380       END IF
12390     ELSE
12400       word(0)=HEX('C100')+size%*HEX('40')
12410       IF dtype=1 THEN
12420           IF stype=2:operr
12430           word(0)=word(0)+regd%*HEX('200')+amodes%*HEX('8')+regs%
12440         ELSE
12450           IF stype<>1:operr
12460           SELect ON dtype=2,10 TO 16:operr
12470           word(0)=word(0)+regs%*HEX('200')+amoded%*h('8')+regd%
12480       END IF
12490   END IF
12500   len%=2+overhead(stype,mn$,src$)+overhead(dtype,mn$,dest$)
12510   opcode
12520   pc=pc+len%
12530 END DEFine link1
12540 :
12550 DEFine PROCedure link2
12560   LOCal i%,len%,size%,t$
12570   sizetemp
12580   IF dest$='' THEN
12590       SELect ON stype=1,2,10 TO 16:operr
12600       word(0)=word(0)+HEX('E1C0')+amode%*HEX('8')+regs%
12610       len%=2+overhead(src$,mn$,stype)
12620       opcode
12630     ELSE
12640       IF dtype<>1:operr
12650       word(0)=HEX('E100')+size%*HEX('40')+regd%
12660       IF stype=1 THEN
12670           word(0)=word(0)+regs%*HEX('200')+HEX('20')
12680         ELSE
12690           word(0)=word(0)+(eval(src$) MOD 8)*HEX('200')
12700       END IF
12710       len%=2
12720       obj$=cvs$(word(0),2)
12730   END IF
12740   pc=pc+len%
12750 END DEFine link2
12760 :
12770 DEFine PROCedure link3
12780   link2
12790   word(0)=word(0)-HEX('100')
12800   opcode
12810 END DEFine link3
12820 :
12830 DEFine PROCedure link39
12840   LOCal len%
12850   SELect ON stype=2 TO 11,14 TO 16:operr
12860   SELect ON dtype=2,10 TO 16:operr
12870   IF stype=1 THEN
12880       word(0)=HEX('140')+regs%*HEX('200')+amoded%*HEX('8')+regd%
12890     ELSE
12900       word(0)=HEX('840')+amoded%*HEX('8')+regd%
12910   END IF
12920   len%=2+overhead(stype,mn$,src$)+overhead(dtype,mn$,dest$)
12930   opcode
12940   pc=pc+len%
12950 END DEFine link39
12960 :
12970 DEFine PROCedure link40
12980   link39
12990   word(0)=word(0)+HEX('40')
13000   opcode
13010 END DEFine link40
13020 :
13030 DEFine PROCedure link6
13040   LOCal temp,disp%
13050   word(0)=HEX('6100')
13060   temp=eval(src$)
13070   pc=pc+2
13080   disp%=temp-pc
13090   IF disp%>-126 AND disp%<127 OR mn$(LEN(mn$)-1 TO)='.S' THEN
13100       word(0)=word(0)+256*(disp%<0)+disp%
13120       obj$=cvs$(word(0),2)
13130     ELSE
13140       obj$=cvs$(word(0),2)&cvs$(disp%,2)
13150       pc=pc+2
13160   END IF
13165   IF mn$(LEN(mn$)-1 TO)='.S' AND(disp%<-128 OR disp%>127):operr
13170 END DEFine link6
13180 :
13190 DEFine PROCedure link42
13200   LOCal len%
13210   IF stype=2 OR dtype<>1:operr
13220   word(0)=HEX('4180')+regd%*HEX('200')+amodes%*HEX('8')+regs%
13230   len%=2+overhead(stype,mn$,src$)
13240   opcode
13250   pc=pc+len%
13260 END DEFine link42
13270 :
13280 DEFine PROCedure link43
13290   LOCal len%
13300   IF stype=1 OR dtype<>1:operr
13310   word(0)=HEX('81C0')+regd%*HEX('200')+amodes%*HEX('8')+regs%
13320   len%=2+overhead(stype,mn$,src$)
13330   opcode
13340   pc=pc+len%
13350 END DEFine link43
13360 :
13370 DEFine PROCedure link44
13380   link43
13390   word(0)=word(0)-HEX('100')
13400   opcode
13410 END DEFine link44
13420 :
13430 DEFine PROCedure link9
13440   LOCal i%,len%,size%,t$
13450   sizetemp
13460   IF t$(i%)='I' THEN
13470       IF stype<>12 OR stype<>13:operr
13480       SELect ON dtype=2,10 TO 16:operr
13490       word(0)=HEX('A00')+size%*HEX('40')+amoded%*HEX('8')+regd%
13500     ELSE
13510       word(0)=HEX('B100')+regs%*HEX('200')+amoded%*HEX('8')+regd%
13520   END IF
13530   len%=2+overhead(stype,mn$,src$)+overhead(dtype,mn$,dest$)
13540   opcode
13550   pc=pc+len%
13560 END DEFine link9
13570 :
13580 DEFine PROCedure link10
13590   SELect ON stype=2,10 TO 16:operr
13600   word(0)=HEX('4EC0')+amodes%*HEX('8')+regs%
13610   len%=2+overhead(stype,mn$,src$)
13620   opcode
13630   pc=pc+len%
13640 END DEFine link10
13650 :
13660 DEFine PROCedure link11
13670   link10
13680   word(0)=word(0)-HEX('40')
13690   opcode
13700 END DEFine link11
13710 :
13720 DEFine PROCedure link46
13730   LOCal len%
13740   IF dtype<>2:operr
13750   SELect ON stype=1,2,4,5,12 TO 16:operr
13760   word(0)=HEX('41C0')+regd%*HEX('200')+amodes%*HEX('8')+regs%
13770   len%=2+overhead(stype,mn$,src$)
13780   opcode
13790   pc=pc+len%
13800 END DEFine link46
13810 :
13820 DEFine PROCedure link47
13830   LOCal len%
13840   IF stype<>2:operr
13850   word(0)=HEX('4E50')+regs%
13860   len%=4
13870   opcode
13880   pc=pc+len%
13890 END DEFine link47
13900 :
13910 DEFine PROCedure link13
13920   link12
13930   word(0)=word(0)-HEX('100')
13940   IF stype=1 OR stype=12 OR stype=13:obj$=cvs$(word(0),2):ELSE opcode
13950 END DEFine link13
13960 :
13970 DEFine PROCedure link25
13980   LOCal i%,len%,size%,t$
13990   IF NOT(stype=1 AND dtype=6) AND NOT(stype=6 AND dtype=1):operr
14000   sizetemp
14010   word(0)=HEX('108')+(size%=2)*shift(6)
14020   IF stype=1 THEN
14030       word(0)=word(0)+HEX('80')+regs%*HEX('200')+regd%
14040     ELSE
14050       word(0)=word(0)+regd%*HEX('200')+regs%
14060   END IF
14070   len%=4
14080   opcode
14090   pc=pc+len%
14100 END DEFine link25
14110 :
14120 DEFine PROCedure link26
14130   LOCal len%
14140   SELect ON stype=2,10 TO 16:operr
14150   IF dtype<>1:operr
14160   word(0)=HEX('C1C0')+regd%*HEX('200')+amodes%*HEX('8')+regs%
14170   len%=2+overhead(stype,mn$,src$)
14180   opcode
14190   pc=pc+len%
14200 END DEFine link26
14210 :
14220 DEFine PROCedure link48
14230   LOCal len%
14240   SELect ON stype=2,10 TO 16:operr
14250   word(0)=HEX('4800')+amodes%*HEX('8')+regs%
14260   len%=2+overhead(stype,mn$,src$)
14270   opcode
14290 END DEFine link48
14300 :
14310 DEFine PROCedure link28
14320   LOCal i%,len%,size%,t$
14330   SELect ON stype=2,10 TO 16:operr
14340   sizetemp
14350   word(0)=HEX('4800')+size%*HEX('40')+amodes%+regs%
14360   IF t$(i%)='X':word(0)=word(0)-HEX('800')
14370   len%=2+overhead(stype,mn$,src$)
14380   opcode
14390   pc=pc+len%
14400 END DEFine link28
14410 :
14420 DEFine PROCedure link29
14430   word(0)=HEX('4E71')
14440   obj$=cvs$(word(0),2)
14450   pc=pc+2
14460 END DEFine link29
14470 :
14480 DEFine PROCedure link15
14490   LOCal i%,len%,size,t$
14500   sizetemp
14510   link1
14520   IF t$(i%)='I' THEN
14530       word(0)=word(0)-HEX('200')
14540     ELSE
14550       word(0)=word(0)-HEX('4000')
14560   END IF
14570   opcode
14580 END DEFine link15
14590 :
14600 DEFine PROCedure link49
14610   LOCal len%
14620   SELect ON stype=2,10 TO 16:operr
14630   word(0)=HEX('4840')+amodes%*HEX('8')+regs%
14640   len%=2+overhead(stype,mn$,src$)
14650   opcode
14660   pc=pc+len%
14670 END DEFine link49
14680 :
14690 DEFine PROCedure link50
14700   word(0)=HEX('4E70')
14710   obj$=cvs$(word(0),2)
14720   pc=pc+2
14730 END DEFine link50
14740 :
14750 DEFine PROCedure link16
14760   link17
14770   word(0)=word(0)+HEX('100')
14780   IF stype=12 OR stype=1:obj$=cvs$(word(0),2):ELSE opcode
14790 END DEFine link16
14800 :
14810 DEFine PROCedure link17
14820   link13
14830   IF stype=12 OR stype=1 THEN
14840       word(0)=word(0)+HEX('10')
14850       obj$=cvs$(word(0),2)
14860     ELSE
14870       word(0)=word(0)+HEX('400')
14880       opcode
14890   END IF
14900 END DEFine link17
14910 :
14920 DEFine PROCedure link31
14930   link16
14950   word(0)=word(0)-HEX('8')
14955   IF stype=1 OR stype=12:obj$=cvs$(word(0),2):ELSE opcode
15010 END DEFine link31
15020 :
15030 DEFine PROCedure link32
15040   link31
15050   word(0)=word(0)-HEX('8')
15060   IF stype=1 OR stype=12:obj$=cvs$(word(0),2):ELSE opcode
15070 END DEFine link32
15080 :
15090 DEFine PROCedure link33
15100   word(0)=HEX('4E73')
15110   obj$=cvs$(word(0),2)
15120   pc=pc+2
15130 END DEFine link33
15140 :
15150 DEFine PROCedure link34
15160   word(0)=HEX('4E77')
15170   obj$=cvs$(word(0),2)
15180   pc=pc+2
15190 END DEFine link34
15200 :
15210 DEFine PROCedure link35
15220   link20
15230   word(0)=word(0)-HEX('4000')
15240   obj$=cvs$(word(0),2)
15250 END DEFine link35
15260 :
15270 DEFine PROCedure link51
15280   LOCal i%,len%,t%
15290   SELect ON stype=2,10 TO 16:operr
15300   FOR i%=0 TO 15
15310     IF mn$='S'&cond$(i%) THEN
15320         t%=cond%(i%)
15330         EXIT i%
15340     END IF
15350   END FOR i%
15360   word(0)=HEX('50C0')+t%*HEX('100')+amodes%*HEX('8')+regs%
15370   len%=2+overhead(stype,mn$,src$)
15380   opcode
15390   pc=pc+len%
15400 END DEFine link51
15410 :
15420 DEFine PROCedure link36
15430   word(0)=HEX('4E72')
15440   opcode
15450   pc=pc+4
15460 END DEFine link36
15470 :
15480 DEFine PROCedure link37
15490   IF stype<>1:operr
15500   word(0)=HEX('4840')+regs%
15510   obj$=cvs$(word(0),2)
15520   pc=pc+2
15530 END DEFine link37
15540 :
15550 DEFine PROCedure link52
15560   LOCal len%
15570   SELect ON stype=2,10 TO 16:operr
15580   word(0)=HEX('4AC0')+amodes%*HEX('8')+regs%
15590   LEN=2+overhead(stype,mn$,src$)
15600   opcode
15610   pc=pc+len%
15620 END DEFine link52
15630 :
15640 DEFine PROCedure link53
15650   IF stype<>12:operr
15660   word(0)=HEX('4E40')+(eval(src$) MOD 16)
15670   obj$=cvs$(word(0),2)
15680   pc=pc+2
15690 END DEFine link53
15700 :
15710 DEFine PROCedure link54
15720   word(0)=HEX('4E76')
15730   obj$=cvs$(word(0),2)
15740   pc=pc+2
15750 END DEFine link54
15760 :
15770 DEFine PROCedure link55
15780   IF stype<>2:operr
15790   word(0)=HEX('4E58')+regs%
15800   obj$=cvs$(word(0),2)
15810   pc=pc+2
15820 END DEFine link55
15830 :
15840 DEFine PROCedure link24
15850   LOCal i%,j,rlist$,len%,t$,delim$,size%
15860   sizetemp
15870   IF stype=16 THEN
15880       SELect ON dtype=1,2,4,10 TO 16:operr
15890       rlist$=src$
15900       word(0)=HEX('4880')+amoded%*HEX('8')+regd%
15910       len%=2+overhead(dtype,mn$,dest$)
15920     ELSE
15930       IF dtype<>16:operr
15940       SELect ON stype=1,2,5,12 TO 16:operr
15950       rlist$=dest$
15960       word(0)=HEX('4C80')+amodes%*HEX('8')+reg%
15970       len%=2+overhead(stype,mn$,src$)
15980   END IF
15990   IF size%=2:word(0)=word(0)+HEX('40')
16000   opcode
16010   word(1)=0
16020   REPeat j
16030     IF rlist$='':EXIT j
16040     IF '-' INSTR rlist$ OR '/' INSTR rlist$ THEN
16041         t$=rlist$(TO 3)
16042         rlist$=rlist$(4 TO)
16043       ELSE
16044         t$=rlist$
16045         rlist$=''
16046     END IF
16050     delim$=t$(LEN(t$)):IF delim$<>'/' AND delim$<>'-' THEN delim$=''
16060     IF delim$='/' THEN reglist t$,dtype:NEXT j
16070     IF delim$='' THEN reglist t$,dtype:EXIT j
16080     IF delim$='-' THEN
16090         delim$=rlist$(TO 2)
16100         IF LEN(rlist$)>2 THEN
16110             IF rlist$(3)='/' THEN
16111                 rlist$=rlist$(4 TO)
16112               ELSE
16113                 rlist$=rlist$(3 TO)
16114             END IF
16120           ELSE
16130             rlist$=''
16140         END IF
16150         FOR i%=t$(2) TO delim$(2)
16160           reglist t$(1)&i%,dtype
16170         END FOR i%
16180     END IF
16190   END REPeat j
16200   IF LEN(obj$)>2 THEN
16201       obj$=obj$(TO 2)&cvs$(word(1),2)&obj$(3 TO)
16202     ELSE
16203       obj$=obj$&cvs$(word(1),2)
16204   END IF
16210   len%=len%+2
16220   pc=pc+len%
16230 END DEFine link12
16240 :
16250 DEFine PROCedure reglist(temp$,dtype)
16260   LOCal i%
16270   i%=reg(temp$(TO 2),0)
16280   IF temp$(1)='A':i%=i%+8
16290   IF dtype=5:i%=15-i%
16300   word(1)=word(1)+2^i%
16310 END DEFine reglist
16320 :
16330 DEFine FuNction expression(t$)
16340   LOCal t,t1$,t2$,op$,k,i%
16345   IF t$='[*]':RETurn pc
16350   t$=t$(('[' INSTR t$)+1 TO (']' INSTR t$)-1)
16360   FOR i%=1 TO LEN(t$)
16370     IF t$(i%)='+' OR t$(i%)='-' THEN
16380         op$=t$(i%)
16390         t1$=t$(TO i%-1)
16400         t$=t$(i%+1 TO)
16410         EXIT i%
16420     END IF
16430   END FOR i%
16440   t=eval(t$)
16450   REPeat k
16460     FOR i%=1 TO LEN(t$)
16470       IF t$(i%)='+' OR t$(i%)='-' THEN
16480           t2$=t$(TO i%-1)
16490           IF op$='+' THEN t=t+eval(t$):ELSE t=t-eval(t$)
16500           op$=t$(i%)
16510           IF LEN(t$)>i% THEN t$=t$(i%+1 TO):ELSE t$=''
16520           EXIT i%
16530       END IF
16540     END FOR i%
16550     IF t$='':EXIT k
16560     IF NOT('+' INSTR t$ OR '-' INSTR t$) THEN
16570         IF op$='+' THEN t=t+eval(t$):ELSE t=t-eval(t$)
16580         EXIT k
16590     END IF
16600   END REPeat k
16610   RETurn t
16620 END DEFine expression
16630 :
16640 DEFine PROCedure operr
16650   ec%=ferror('Operand error',ec%)
16660 END DEFine operr
